import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Turtle using recursion to draw a fractal tree
 * 
 * @author Paul Clark et al.
 * @version 0.2
 */
public class MagicTurtles extends Turtle
{
    private double size;              // in pixels
    private double scale;             // must be < 1 to shrink size in order to terminate
    private int    age = 0;
    
    public MagicTurtles()
    {
        // Default parameters, bit like an Ash tree
        size = 200;
        scale= 0.65;
        turnNorth();
    }
    
    public MagicTurtles(double pixels, double s, double d)
    {
        // Default parameters, bit like an Ash tree
        size = pixels;
        scale= s;
        turn(d);
    }


    public void setSize(double pixels)
    {
        size = pixels;
    }

    public void setScale(double s)
    {
        scale = s;
    }

    /**
     * Action:  Draw one tree and return to start position
     */
    public void act()
    {
        // Draw tree
        if (age == 0)
            penDown();
        if (age == 1)
             move(size);
        if (age == 2 && size >2)
        {
            getWorld().addObject(new MagicTurtles(size*scale,scale,direction-60),getX(),getY()); 
            getWorld().addObject(new MagicTurtles(size*scale,scale,direction+60),getX(),getY()); 
        }
        if (age == 3)    
                        getWorld().removeObject(this);
        age += 1;
    }

}
